import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["checked", "checkedIcon", "disabled", "id", "intermediate", "intermediateIcon", "isNative", "name", "onChange", "status"];
import { useRef } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var BASE_CLASS = 'sui-AtomCheckbox';
var CHECKBOX_STATUS = {
  ERROR: 'error',
  SUCCESS: 'success',
  ALERT: 'alert'
};

var AtomCheckbox = function AtomCheckbox(_ref) {
  var _cx;

  var _ref$checked = _ref.checked,
      checked = _ref$checked === void 0 ? false : _ref$checked,
      CheckedIcon = _ref.checkedIcon,
      disabled = _ref.disabled,
      id = _ref.id,
      _ref$intermediate = _ref.intermediate,
      intermediate = _ref$intermediate === void 0 ? false : _ref$intermediate,
      IntermediateIcon = _ref.intermediateIcon,
      _ref$isNative = _ref.isNative,
      isNativeProp = _ref$isNative === void 0 ? false : _ref$isNative,
      name = _ref.name,
      _ref$onChange = _ref.onChange,
      onChangeFromProps = _ref$onChange === void 0 ? function () {} : _ref$onChange,
      status = _ref.status,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var inputRef = useRef();
  var hasNotCustomIcons = !CheckedIcon && !IntermediateIcon;
  var isNative = isNativeProp || hasNotCustomIcons;
  var isIntermediate = intermediate && !checked;

  var updateNativeIndeterminate = function updateNativeIndeterminate() {
    inputRef.current && (inputRef.current.indeterminate = isIntermediate);
  };

  var handleChange = function handleChange(ev) {
    // Handler doesn't necessarily trigger render, but browser could still set
    // native indeterminate property which may end up in a mismatch between it
    // and the component's prop, so native value should be kept updated here.
    updateNativeIndeterminate();
    var _ev$target = ev.target,
        checked = _ev$target.checked,
        name = _ev$target.name;
    if (!disabled) onChangeFromProps(ev, {
      name: name,
      value: checked
    });
  };

  var className = cx(BASE_CLASS, (_cx = {
    'is-checked': checked,
    'is-disabled': disabled,
    'is-intermediate': isIntermediate
  }, _cx[BASE_CLASS + "--native"] = isNative, _cx[BASE_CLASS + "--status-" + status] = Object.values(CHECKBOX_STATUS).includes(status), _cx)); // Keep native indeterminate property updated every render

  updateNativeIndeterminate();
  return /*#__PURE__*/_jsxs("label", {
    className: className,
    children: [!isNative && checked && /*#__PURE__*/_jsx(CheckedIcon, {}), !isNative && isIntermediate && /*#__PURE__*/_jsx(IntermediateIcon, {}), /*#__PURE__*/_jsx("input", _extends({
      ref: inputRef,
      type: "checkbox",
      id: id,
      name: name || id,
      disabled: disabled,
      checked: checked,
      intermediate: isIntermediate ? 'intermediate' : '',
      onChange: handleChange
    }, props))]
  });
};

AtomCheckbox.displayName = 'AtomCheckbox';
export default AtomCheckbox;
export { CHECKBOX_STATUS as checkboxStatus };